<template>
  <div>
    <SearchForm v-on:formSearch="onFormSearch" />
    <SearchResults :filteredOrders="filteredOrders" v-on:editOrder="onEditOrder" />
    <v-snackbar
      :value="snackbar.show"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :timeout="snackbar.timeout"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        dark
        flat
        @click="snackbar.show = false"
      >
        Close
      </v-btn>
    </v-snackbar>
  </div>
</template>
<script>
import { mapGetters, mapActions } from 'vuex'
import SearchForm from '@/components/SearchForm'
import SearchResults from '@/components/SearchResults'

export default {
  name: 'Home',
  components: { SearchForm, SearchResults },
  data: () => ({
    snackbar: {
      show: false,
      color: 'red',
      mode: 'multi-line',
      timeout: 3000,
      text: 'Error'
    }
  }),
  mounted () {
    this.resetResults()
  },
  computed: {
    ...mapGetters('orders', {
      filteredOrders: 'filteredOrders',
      apiMessage: 'apiMessage'
    })
  },
  watch: {
    apiMessage: function (val) {
      if (val) {
        this.snackbar.color = (val.type === 'info') ? 'info' : 'error'
        this.snackbar.text = val.message
        this.snackbar.show = true
      } else {
        this.snackbar.show = false
      }
    }
  },
  methods: {
    ...mapActions('orders', {
      searchOrders: 'searchOrders',
      resetResults: 'resetResults',
      editOrder: 'editOrder'
    }),
    // SearchForm events:
    onFormSearch ({ dateForAPI, status, searchText }) {
      this.searchOrders({ dateForAPI, status, searchText })
    },
    // SearchResult events:
    onEditOrder (editedItem) {
      this.editOrder(editedItem)
    }
  }
}
</script>
